#
# spec file for package taglib
#
# Copyright (c) 2011 SUSE LINUX Products GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild


Name:           taglib
Version:        1.7
Release:        42.1
License:        LGPL-2.1+ ; MPL-1.1
Summary:        Audio Meta-Data Library
Url:            http://ktown.kde.org/~wheeler/taglib/
Group:          System/Libraries
# http://ktown.kde.org/~wheeler/files/src/taglib-1.7.tar.gz
Source0:        %{name}-%{version}.tar.bz2
Source1:        %{name}.desktop
Source100:      baselibs.conf
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
BuildRequires:  cmake
BuildRequires:  doxygen
BuildRequires:  fdupes
BuildRequires:  gcc-c++
BuildRequires:  graphviz-gnome
BuildRequires:  libcppunit-devel
BuildRequires:  pkg-config
%if 0%{?suse_version}
BuildRequires:  update-desktop-files
%endif
BuildRequires:  zlib-devel
Requires:       libtag1 = %{version}
Requires:       libtag_c0 = %{version}

%description
TagLib is a library for reading and editing the meta-data of several popular
audio formats. Currently it supports both ID3v1 and ID3v2 for MP3 files, Ogg
Vorbis comments and ID3 tags and Vorbis comments in FLAC, MPC, Speex, WavPack
TrueAudio, WAV, AIFF, MP4 and ASF files.

%package -n libtag1
License:        LGPL-2.1+
Summary:        Audio Meta-Data Library
Group:          System/Libraries
# Without this the old taglib package containing the libraries isn't removed when this package is installed.
# The only alternative is for the libraries to Require: taglib version-release, badness 440
Conflicts:      taglib <= 1.6.3

%description -n libtag1
TagLib is a library for reading and editing the meta-data of several popular
audio formats. Currently it supports both ID3v1 and ID3v2 for MP3 files, Ogg
Vorbis comments and ID3 tags and Vorbis comments in FLAC, MPC, Speex, WavPack
TrueAudio, WAV, AIFF, MP4 and ASF files.

%package -n libtag_c0
License:        LGPL-2.1+
Summary:        Audio Meta-Data Library
Group:          System/Libraries
# Without this the old taglib package containing the libraries isn't removed when this package is installed.
# The only alternative is for the libraries to Require: taglib version-release, badness 440
Conflicts:      taglib <= 1.6.3

%description -n libtag_c0
TagLib is a library for reading and editing the meta-data of several popular
audio formats. Currently it supports both ID3v1 and ID3v2 for MP3 files, Ogg
Vorbis comments and ID3 tags and Vorbis comments in FLAC, MPC, Speex, WavPack
TrueAudio, WAV, AIFF, MP4 and ASF files.

%package -n libtag-devel
License:        LGPL-2.1+
Summary:        Development files for taglib
Group:          Development/Libraries/C and C++
Requires:       libstdc++-devel
Requires:       libtag_c0 = %{version}-%{release}
Requires:       libtag1 = %{version}-%{release}
# taglib-devel was last used in openSUSE 11.4 (taglib-devel-1.6.2)
# The last taglib-devel used was version 1.6.3 from multimedia:libs.
Provides:       taglib-devel = %{version}
Obsoletes:      taglib-devel <= 1.6.3

%description -n libtag-devel
This package contains development files for taglib.

%prep
%setup -q

%build
mkdir build
cd build
export CXXFLAGS="%{optflags}"
export CFLAGS="%{optflags}"
_libsuffix=$(echo %{_lib} | cut -b4-)
cmake -DCMAKE_INSTALL_PREFIX=%{_prefix} -DBUILD_TESTS:BOOL=ON -DLIB_SUFFIX=$_libsuffix -DWITH_ASF:BOOL=ON -DWITH_MP4:BOOL=ON ..
make %{?_smp_mflags} VERBOSE=1
cd ..

doxygen -u
doxygen

%install
cd build
%makeinstall
cd ..

# install susehelp file
mkdir -p %{buildroot}%{_datadir}/susehelp/meta/Development/Libraries/
install -pm 0644 %{SOURCE1} %{buildroot}%{_datadir}/susehelp/meta/Development/Libraries/

%if 0%{?suse_version}
%suse_update_desktop_file %{buildroot}%{_datadir}/susehelp/meta/Development/Libraries/%{name}.desktop
%endif

# Documentation
mkdir -p %{buildroot}%{_defaultdocdir}/libtag-devel
rm -f examples/CMake*
cp -a AUTHORS COPYING.LGPL COPYING.MPL NEWS doc/html/ examples/ %{buildroot}%{_defaultdocdir}/libtag-devel/

%fdupes -s %{buildroot}

echo <<EOF >README.taglib
This package only acts as a placeholder until all packages that use taglib
have upgraded to the new package names libtag1 and libtag_c0.
EOF

%check
# check the library
#pushd tests
#make check
#popd

%clean
%{?buildroot:%__rm -rf "%{buildroot}"}

%post -n libtag1 -p /sbin/ldconfig

%postun -n libtag1 -p /sbin/ldconfig

%post -n libtag_c0 -p /sbin/ldconfig

%postun -n libtag_c0 -p /sbin/ldconfig

%files -n libtag1
%defattr(-,root,root,-)
%{_libdir}/libtag.so.1
%{_libdir}/libtag.so.1.*

%files -n libtag_c0
%defattr(-,root,root,-)
%{_libdir}/libtag_c.so.0
%{_libdir}/libtag_c.so.0.*

%files -n libtag-devel
%defattr(-,root,root,-)
%doc %{_defaultdocdir}/libtag-devel
%{_bindir}/taglib-config
%{_includedir}/taglib/
%{_libdir}/libtag*.so
%{_libdir}/pkgconfig/*.pc
%{_datadir}/susehelp/

%files
%defattr(-,root,root,-)
%doc README.taglib

%changelog
* Sat May 28 2011 davejplater@gmail.com
- Made taglib become a package again to satisfy the depencies of
  packages that still require it.
* Sat May 28 2011 davejplater@gmail.com
- Conflict the last version of taglib that contained the libraries
  from the library subpackages.
- Make sure the devel package obsoletes the last version of
  taglib-devel where the main package contained the libraries.
- taglib is the name of the srcrpm, moved docs to devel subpackage.
* Wed May 25 2011 coolo@novell.com
- obsolete the right version of taglib
* Sun May 22 2011 pascal.bleser@opensuse.org
- make taglib become a package again, that has only one duty, to require
  libtag1 and libtag_c0 for packages that still require taglib instead of
  the new package names libtag1 and libtag_c0
* Tue May 17 2011 asterios.dramis@gmail.com
- Update to version 1.7:
  * Fixed memory leaks in the FLAC file format parser.
  * Fixed bitrate calculation for WAV files.
  From 1.7 RC1
  * Support for reading/writing tags from Monkey's Audio files. (BUG:210404)
  * Support for reading/writing embedded pictures from WMA files.
  * Support for reading/writing embedded pictures from FLAC files (BUG:218696).
  * Implemented APE::Tag::isEmpty() to check for all APE tags, not just the
    basic ones.
  * Added reading of WAV audio length. (BUG:116033)
  * Exposed FLAC MD5 signature of the uncompressed audio stream via
    FLAC::Properties::signature(). (BUG:160172)
  * Added function ByteVector::toHex() for hex-encoding of byte vectors.
  * WavPack reader now tries to get the audio length by finding the final
    block, if the header doesn't have the information. (BUG:258016)
  * Fixed a memory leak in the ID3v2.2 PIC frame parser. (BUG:257007)
  * Fixed writing of RIFF files with even chunk sizes. (BUG:243954)
  * Fixed compilation on MSVC 2010.
  * Removed support for building using autoconf/automake.
  * API docs can be now built using "make docs".
- Spec file updates:
  * Changes based on openSUSE shared library packaging policy (added libtag1,
    libtag_c0 and libtag-devel packages, removed taglib and taglib-devel
    packages).
  * Changes based on spec-cleaner run.
  * Changed License: to LGPLv2.1+ ; MPLv1.1 ..
  * Updates in Group, Summary and %%description entries.
  * Added libcppunit-devel and pkg-config in BuildRequires.
  * Minor other updates.
- Updated taglib.desktop for susehelp to point to libtag-devel.
* Sat Feb 26 2011 toddrme2178@gmail.com
- update to version 1.6.3
  * Fixed definitions of the TAGLIB_WITH_MP4 and TAGLIB_WITH_ASF macros.
  * Fixed upgrading of ID3v2.3 genre frame with ID3v1 code 0 (Blues).
  * New method `int String::toInt(bool *ok)` which can return whether the conversion to a number was successful.
  * Fixed parsing of incorrectly written lengths in ID3v2 (affects mainly compressed frames).
* Sun Apr 11 2010 tittiatcoke@gmail.com
- update to version 1.6.2
  * Read Vorbis Comments from the first FLAC metadata block,
    if there are multipe ones.
  * Fixed a memory leak in FileRef's OGA format detection.
  * Fixed compilation with the Sun Studio compiler.
  * Handle WM/TrackNumber attributes with DWORD content in WMA files.
  * More strict check if something is a valid MP4 file.
  * Correctly save MP4 int-pair atoms with flags set to 0.
  * Fixed compilation of the test runner on Windows.
  * Store ASF attributes larger than 64k in the metadata library object.
  * Ignore trailing non-data atoms when parsing MP4 covr atoms.
  * Don't upgrade ID3v2.2 frame TDA to TDRC.
* Mon Feb  1 2010 jengelh@medozas.de
- Package baselibs.conf
* Tue Nov  3 2009 beineri@opensuse.org
- Update to version 1.6.1
  * Better detection of the audio codec of .oga files in FileRef.
  * Fixed saving of Vorbis comments to Ogg FLAC files. TagLib tried to
  include the Vorbis framing bit, which is only correct for Ogg Vorbis.
  * Public symbols now have explicitly set visibility to "default" on GCC.
  * Added missing exports for static ID3v1 functions.
  * Fixed a typo in taglib_c.pc
  * Fixed a failing test on ppc64.
  * Support for binary 'covr' atom in MP4 files. TagLib 1.6 treated them
  as text atoms, which corrupted them in some cases.
  * Fixed ID3v1-style genre to string conversion in MP4 files.
* Tue Sep 22 2009 tittiatcoke@gmail.com
- Update to version 1.6
  * New CMake option to build a static version - ENABLE_STATIC.
  * Added support for disabling dllimport/dllexport on Windows
    using the TAGLIB_STATIC macro.
  * Support for parsing the obsolete 'gnre' MP4 atom.
  * New cpp macros TAGLIB_WITH_MP4 and TAGLIB_WITH_ASF to determine
    if TagLib was built with MP4/ASF support.
  * Split Ogg packets larger than 64k into multiple pages.
  * TagLib can now use FLAC padding block.
  * ID3v2.2 frames are now not incorrectly saved.
  * Support for ID3v2.2 PIC frames.
  * Fixed a bug in ByteVectorList::split().
  * XiphComment::year() now falls back to YEAR if DATE doesn't exist
    and XiphComment::year() falls back to TRACKNUM if TRACKNUMBER
    doesn't exist.
  * Improved ID3v2.3 genre parsing.
  * Better checking of corrupted ID3v2 APIC data.
  * Bitrate calculating using the Xing header now uses floating
    point numbers.
  * New TagLib::String method rfind().
  * Added support for MP4 file format with iTunes-style metadata
  * Added support for ASF (WMA) file format.
  * Fixed crash when saving a Locator APEv2 tag.
  * Fixed a possible crash in the non-const version of String::operator[]
    and in String::operator+=.
  * Added support for PRIV ID3v2 frames.
  * Empty ID3v2 genres are no longer treated as numeric ID3v1 genres.
  * Added support for the POPM (rating/playcount) ID3v2 frame.
  * Generic RIFF file format support:
  * Support for AIFF files with ID3v2 tags.
  * Support for WAV files with ID3v2 tags.
  * Fixed crash on handling unsupported ID3v2 frames, e.g. on encrypted
    frames.
  * Fixed overflow while calculating bitrate of FLAC files with a very
    high bitrate
* Tue Mar 10 2009 coolo@suse.de
- fix build with new cmake
* Wed Jan  7 2009 olh@suse.de
- obsolete old -XXbit packages (bnc#437293)
* Thu Apr 10 2008 dmueller@suse.de
- fix build for older distros
* Thu Apr 10 2008 ro@suse.de
- added baselibs.conf file to build xxbit packages
  for multilib support
* Fri Feb 22 2008 crrodriguez@suse.de
- build using Cmake
- update to version 1.5
  * Support for Mac OS X and Microsoft Windows
  * Distributed under the MPL (in addition to the previous LGPL license)
  * Added support for Speex files
  * Added support for TrueAudio files
  * Added support for WavPack files
  * Added support for ID3v2 general encapsulated object frames
  * Added support for ID3v2 unsynchronized lyrics frames
  * Added support for ID3v2 URL frames
  * Propper exports of all public classes / functions
  * Updated the APE::Item API to work with value lists
  * Added support to the FileRef class for new Xiph (Ogg) extensions
  * Made the samples per frame for MPEG headers accessible
  * Made MP3 Xing headers accessible
  * Prevent invalid encodings from being written to ID3v1 tags
  * Non-Latin1 ID3v2 text frames are automatically converted to UTF-8 on write (if they are not explicitly set to UTF-16)
  * Added support for reading ID3v2.2/3 unsynchronized tags
  * Made it possible to search for ID3v2 comment frames by description
  * Fixed a number of bugs in ID3v2 relative volume adjustment reading and writing
  * Added work arounds for iTunes writing invalid ID3v2 frame lengths
  * Added work arounds for iTunes not being able to correctly parse numerical ID3v2 genres
  * Added work arounds for iTunes putting non-text information in ID3v2 comment frames
  * Added a function to export strings to std::wstring
  * Added a function to check ASCII compatibility of strings
  * Added a function to check Latin1 compatibility of strings
* Wed Nov  7 2007 meissner@suse.de
- fixed gcc4.3 build
* Tue Aug  7 2007 crrodriguez@suse.de
- fix more issues:
  - this package does NOT require libjpeg-devel for build
  - after adding missing zlib-devel on BuildRequires in the
    previous checkin, libtool archives causes bloat.
* Tue Aug  7 2007 crrodriguez@suse.de
- run ldconfig instead of using deprecated macro
- move the docs to the devel packages
- use fdupes to avoid duplicate files
- run make check in the check section
* Fri Oct 20 2006 dmueller@suse.de
- fix build with automake 1.10
* Tue Sep 12 2006 dmueller@suse.de
- fix include's in installed headers
* Mon Jul  3 2006 cthiel@suse.de
- fix build
* Wed Jun 14 2006 dmueller@suse.de
- build parallel
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Nov 29 2005 ro@suse.de
- added fontconfig to nfb
* Mon Sep 26 2005 mls@suse.de
- make devel package require base package
* Tue Aug  9 2005 dmueller@suse.de
- fix filelist
* Tue Aug  9 2005 dmueller@suse.de
- don't package empty TODO file
* Thu Jul 28 2005 adrian@suse.de
- update to version 1.4
* Mon Nov  8 2004 adrian@suse.de
- update to version 1.3.1
  * 64bit OGG/Vorbis file lenght fixes
  * crash fixes with broken mp3 files
* Fri Oct  1 2004 adrian@suse.de
- fix susehelp entry for API documentation
* Fri Sep 10 2004 adrian@suse.de
- update to version 1.3
  * support for AOE tags and MPC files
  * compressed ID3v2 frame support
  * several checks for SIGFPE
* Wed Jul 28 2004 adrian@suse.de
- update to version 1.2
  * flac in ogg support
  * support for relativ volume adjustement
  * support for attached picture
* Sun Apr 18 2004 adrian@suse.de
- update to version 1.1
  * bugfixes
  * some more supported tag types
  * speed improvements
* Wed Jan 21 2004 adrian@suse.de
- update to version 1.0 final
- generate and install API documentation
* Mon Dec 15 2003 adrian@suse.de
- update to version 0.96 (beta 2)
* Thu Nov 13 2003 adrian@suse.de
- update to current HEAD, to get kdemultimedia compiling again
* Mon Nov  3 2003 adrian@suse.de
- package also taglib_c.so
* Mon Nov  3 2003 adrian@suse.de
- update to version 0.95 (beta 1)
* Thu Oct 30 2003 adrian@suse.de
- initial package from kdeextragear-2/taglib snapshot
